/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: StarURLConnection.java,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:49:48 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

package com.sun.xmlsearch.util;

import java.io.*;
import java.util.*;
import java.net.*;

public final class StarURLConnection extends URLConnection {
    public StarURLConnection(URL starURL) {
	super(starURL);
	System.out.println("creating StarURLConnection");
	setDoInput(true);
	connected = true;
    }
	
    public void connect() throws IOException  {
	System.out.println("trying to Star-connect");
    }
	
    public InputStream getInputStream() {
	System.out.println("getting getInputStream");
	String doc =
	    "<HTML><H1> text from get byte stream: <B>ABC 123</B>"
	    + "</H1><EMBEDDEDTEXT id=\"36\"><B>from InputStream</B></EMBEDDEDTEXT></HTML>";
	return new ByteArrayInputStream(doc.getBytes());
    }
}
