/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: crwg_grp.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 16:04:55 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef ARY_CPP_CRWG_GRP_HXX
#define ARY_CPP_CRWG_GRP_HXX


// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
	// PARAMETERS
#include <ary/ids.hxx>


namespace ary
{
namespace cpp
{
    class ProjectGroup;
    class FileGroup;


class RwGate_Groups
{
  public:
    // LIFECYCLE
    virtual             ~RwGate_Groups() {}

	// OPERATIONS
	ProjectGroup &      CheckIn_ProjectGroup(
							const udmstri &     i_sName,
                            Lid                 i_nSourceCodeRootDirectory );
	FileGroup &         CheckIn_FileGroup(
                            Lid                 i_nSourceCodeFile,
                            Gid                 i_nProjectGroup,
                            const udmstri &     i_sFileName );

  private:
	virtual ProjectGroup &
                        do_CheckIn_ProjectGroup(
							const udmstri &     i_sName,
                            Lid                 i_nSourceCodeRootDirectory ) = 0;
	virtual FileGroup & do_CheckIn_FileGroup(
                            Lid                 i_nSourceCodeFile,
                            Gid                 i_nProjectGroup,
                            const udmstri &     i_sFileName ) = 0;
};


inline ProjectGroup &
RwGate_Groups::CheckIn_ProjectGroup( const udmstri &     i_sName,
                                     Lid                 i_nSourcecodeRootDirectory )
    { return do_CheckIn_ProjectGroup(i_sName, i_nSourcecodeRootDirectory); }
inline FileGroup &
RwGate_Groups::CheckIn_FileGroup( Lid               i_nSourceCodeFile,
                                  Gid               i_nProjectGroup,
                                  const udmstri &   i_sFileName )
    { return do_CheckIn_FileGroup(i_nSourceCodeFile, i_nProjectGroup, i_sFileName); }


}   // namespace cpp
}   // namespace ary



#endif

