/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: ce_null.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/16 16:31:16 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_autodoc.hxx"

#include <precomp.h>
#include <ce_null.hxx>


// NOT FULLY DEFINED SERVICES
#include <ary/docu.hxx>


namespace ary
{

CodeEntity_Null::~CodeEntity_Null()
{
}

void
CodeEntity_Null::do_StoreAt( ary::Display & ) const
{
    // Ignore and do nothing.
}

Rid
CodeEntity_Null::inq_Id() const
{
    return 0;
}

RCid
CodeEntity_Null::inq_RC() const
{
    return 0;
}

const Documentation &
CodeEntity_Null::inq_Info() const
{
    return Documentation::Null_();
}

void
CodeEntity_Null::do_Add_Documentation( DYN ary::Documentation & )
{
    // Ignore and do nothing.
}

const udmstri &
CodeEntity_Null::inq_LocalName() const
{
    return udmstri::Null_();
}

Cid
CodeEntity_Null::inq_Owner() const
{
    return 0;
}

Lid
CodeEntity_Null::inq_Location() const
{
    return 0;
}


}   // namespace ary


