/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sto_cpp.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 17:19:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef ARY_STORE_STO_CPP_HXX
#define ARY_STORE_STO_CPP_HXX



// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
	// PARAMETERS


namespace ary
{
	namespace cpp
	{
		class ProjectGroup;
		class FileGroup;

		class TypeOwnerNode;
		class UsedType;

		class Define;
		class Macro;

        class OperationSignature;
    }

	class CodeEntity;

namespace store
{
    template <class XY> class ReStorage;


class Cpp
{
  public:
                        Cpp();
                        ~Cpp();

    ReStorage< ary::CodeEntity > &
                        Ces();

	ReStorage< ary::cpp::UsedType > &
						UsedTypes();
	ReStorage< ary::cpp::OperationSignature > &
    					OSigns();

	ReStorage< ary::cpp::Define > &
						Defines();
	ReStorage< ary::cpp::Macro > &
						Macros();
  private:
    struct Cpp_Impl;

    // DATA
    Dyn< Cpp_Impl >     pi;
};


}   // namespace store
}   // namespace ary

#endif

