/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: moptions.cxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/17 00:29:22 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_basctl.hxx"


#include <ide_pch.hxx>


#ifndef _SBXCLASS_HXX //autogen
#include <basic/sbx.hxx>
#endif
#include <moptions.hxx>
#include <moptions.hrc>
#include <iderid.hxx>
#include <basobj.hxx>

MacroOptionsDialog::MacroOptionsDialog( Window* pParent, SbxVariable* pV )
	: ModalDialog( pParent, 	IDEResId(RID_MACROOPTIONS ) ),
		aSbxName( this, 		IDEResId( RID_FT_SBXNAME ) ),
		aOKButton( this, 		IDEResId( RID_PB_OK ) ),
		aCancelButton( this, 	IDEResId( RID_PB_CANCEL ) ),
		aHelpButton( this, 		IDEResId( RID_PB_HELP ) ),
        aFixedLine( this, 		IDEResId( RID_FL_HELP ) ),
        aDescription( this, 	IDEResId( RID_ME_DESCR ) ),
		aDescrText( this, 		IDEResId( RID_FT_DESCR ) ),
		aHelpIdText( this, 		IDEResId( RID_FT_HELPID ) ),
		aHelpFileText( this, 	IDEResId( RID_FT_HELPNAME ) ),
		aHelpId( this, 			IDEResId( RID_NF_HELPID ) ),
		aHelpFile( this, 		IDEResId( RID_ED_HELPNAME ) )
{
	FreeResource();

	Font aFont( aSbxName.GetFont() );
	aFont.SetWeight( WEIGHT_BOLD );
	aSbxName.SetFont( aFont );

	pVariable = pV;
	aSbxName.SetText( pVariable->GetName() );
	SbxInfoRef xInfo = pVariable->GetInfo();
	if ( xInfo.Is() )
	{
		aDescription.SetText( xInfo->GetComment() );
		aHelpFile.SetText( xInfo->GetHelpFile() );
		aHelpId.SetValue( xInfo->GetHelpId() );
	}

	aOKButton.SetClickHdl( LINK( this, MacroOptionsDialog, ButtonHdl ) );
	aCancelButton.SetClickHdl( LINK( this, MacroOptionsDialog, ButtonHdl ) );
//	aHelpButton.SetClickHdl( LINK( this, MacroOptionsDialog, ButtonHdl ) );
}



IMPL_LINK( MacroOptionsDialog, ButtonHdl, Button *, pButton )
{
	if ( pButton == &aOKButton )
		EndDialog( TRUE );
	else if ( pButton == &aCancelButton )
		EndDialog( FALSE );

    return 0;
}



short __EXPORT MacroOptionsDialog::Execute()
{
	aDescription.GrabFocus();
	return ModalDialog::Execute();
}



