/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: LayoutDefaults.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 00:41:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef CHART_LAYOUTDEFAULTS_HXX
#define CHART_LAYOUTDEFAULTS_HXX

#ifndef _COM_SUN_STAR_LAYOUT_ALIGNMENT_HPP_
#include <com/sun/star/layout/Alignment.hpp>
#endif
#ifndef _COM_SUN_STAR_LAYOUT_CELLCOORDINATE_HPP_
#include <com/sun/star/layout/CellCoordinate.hpp>
#endif
#ifndef _COM_SUN_STAR_LAYOUT_WEIGHT_HPP_
#include <com/sun/star/layout/Weight.hpp>
#endif
#ifndef _COM_SUN_STAR_LAYOUT_PADDING_HPP_
#include <com/sun/star/layout/Padding.hpp>
#endif

namespace layout_defaults
{
// Alignment
static const ::com::sun::star::layout::Alignment
    const_aCenter( 0.5, 0.5, true, true );

static const ::com::sun::star::layout::Alignment
    const_aPageStart(      0.5, 0.0, true, true );
static const ::com::sun::star::layout::Alignment
    const_aFirstLineStart( 0.0, 0.0, true, true );
static const ::com::sun::star::layout::Alignment
    const_aLineStart(      0.0, 0.5, true, true );
static const ::com::sun::star::layout::Alignment
    const_aLastLineStart(  0.0, 1.0, true, true );
static const ::com::sun::star::layout::Alignment
    const_aPageEnd(        0.5, 1.0, true, true );
static const ::com::sun::star::layout::Alignment
    const_aLastLineEnd(    1.0, 1.0, true, true );
static const ::com::sun::star::layout::Alignment
    const_aLineEnd(        1.0, 0.5, true, true );
static const ::com::sun::star::layout::Alignment
    const_aFirstLineEnd(   1.0, 0.0, true, true );

static const ::com::sun::star::layout::Alignment
    const_aNorth(          0.5, 0.0, false, true );
static const ::com::sun::star::layout::Alignment
    const_aNorthWest(      0.0, 0.0, false, true );
static const ::com::sun::star::layout::Alignment
    const_aWest(           0.0, 0.5, false, true );
static const ::com::sun::star::layout::Alignment
    const_aSouthWest(      0.0, 1.0, false, true );
static const ::com::sun::star::layout::Alignment
    const_aSouth(           0.5, 1.0, false, true );
static const ::com::sun::star::layout::Alignment
    const_aSouthEast(       1.0, 1.0, false, true );
static const ::com::sun::star::layout::Alignment
    const_aEast(           1.0, 0.5, false, true );
static const ::com::sun::star::layout::Alignment
    const_aNorthEast(      1.0, 0.0, false, true );

// CellCoordinate
static const ::com::sun::star::layout::CellCoordinate
    const_aRelativeCell( -1, -1 );

static const ::com::sun::star::layout::CellCoordinate
    const_aOneCell( 1, 1 );

// CellPadding
static const ::com::sun::star::layout::Padding
    const_aFivePercentPadding( 5, 5, 5, 5 );

static const ::com::sun::star::layout::Padding
    const_aTenPercentPadding( 10, 10, 10, 10 );

// Weight
static const ::com::sun::star::layout::Weight
    const_aOneWeight( 1.0, 1.0 );

} //  namespace layout

// CHART_LAYOUTDEFAULTS_HXX
#endif
