/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: Increment.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:01:31 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef CHART_INCREMENT_HXX
#define CHART_INCREMENT_HXX

// #ifndef _CPPUHELPER_IMPLBASE2_HXX_
// #include <cppuhelper/implbase2.hxx>
// #endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#include "ServiceMacros.hxx"

#ifndef _COM_SUN_STAR_CHART2_XINCREMENT_HPP_
#include <com/sun/star/chart2/XIncrement.hpp>
#endif
// #ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
// #include <com/sun/star/lang/XServiceInfo.hpp>
// #endif

namespace chart
{

class Increment : public ::cppu::WeakImplHelper1<
    ::com::sun::star::chart2::XIncrement// ,
//     ::com::sun::star::lang::XServiceInfo
    >
{
public:
	Increment();
	virtual ~Increment();

    /// XServiceInfo declarations
    APPHELPER_XSERVICEINFO_DECL()

protected:
    // ____ XIncrement ____
    virtual void SAL_CALL setIncrementData( const ::com::sun::star::chart2::IncrementData& aIncrement )
        throw (::com::sun::star::lang::IllegalArgumentException,
               ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::chart2::IncrementData SAL_CALL getIncrementData()
        throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setSubIncrements( const ::com::sun::star::uno::Sequence<
                                            ::com::sun::star::chart2::SubIncrement >& aSubIncrements )
        throw (::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence<
        ::com::sun::star::chart2::SubIncrement > SAL_CALL getSubIncrements()
        throw (::com::sun::star::uno::RuntimeException);

private:
    ::com::sun::star::chart2::IncrementData         m_aIncrement;
    ::com::sun::star::uno::Sequence<
        ::com::sun::star::chart2::SubIncrement >    m_aSubIncrements;
};

} //  namespace chart

// CHART_INCREMENT_HXX
#endif
