/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: errorhdl.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 19:47:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONREQUEST_HPP_
#include <com/sun/star/task/XInteractionRequest.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_IOERRORCODE_HPP_ //autogen
#include <com/sun/star/ucb/IOErrorCode.hpp>
#endif

#define EC_YES		0x0004
#define EC_NO		0x0008
#define EC_RETRY	0x0010
#define EC_ABORT	0x0020

::com::sun::star::ucb::IOErrorCode SvStreamErrorToUCBIoErrorCode( ULONG nError );

#include <cppuhelper/implbase1.hxx> 

class InteractionRequest_impl : public ::cppu::WeakAggImplHelper1< ::com::sun::star::task::XInteractionRequest >
{
private:
	::com::sun::star::uno::Any maRequest;
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::task::XInteractionContinuation > > maContinuations;

public:
	InteractionRequest_impl( const ::com::sun::star::uno::Any& rRequest, USHORT nResponseFlags );

	USHORT getSelection() const;

	// XInteractionRequest
	virtual ::com::sun::star::uno::Any SAL_CALL getRequest(void) throw(  ::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::task::XInteractionContinuation > > SAL_CALL getContinuations(void) throw(  ::com::sun::star::uno::RuntimeException);
};

