/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: packer.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 19:48:36 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XARCHIVER_HPP_
#include <com/sun/star/util/XArchiver.hpp>
#endif

#include <cppuhelper/implbase2.hxx> 

class UnoPacker : public ::cppu::WeakAggImplHelper2< ::com::sun::star::util::XArchiver, ::com::sun::star::lang::XServiceInfo >
{
public:
	UnoPacker();
	virtual ~UnoPacker();

    // XServiceInfo
    ::rtl::OUString SAL_CALL getImplementationName() throw();
    static ::rtl::OUString          getImplementationName_Static() throw()
	{
		return rtl::OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.extensions.Archiver"));
	}
    sal_Bool SAL_CALL supportsService(const ::rtl::OUString& ServiceName) throw();
    ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(void) throw();
    static ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames_Static(void) throw();

	// XPacker
    virtual sal_Bool SAL_CALL pack(const ::com::sun::star::uno::Sequence< ::rtl::OUString >& input, const ::rtl::OUString& destination, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs) throw(  ::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL unpack(const ::rtl::OUString& destinationpath, const ::rtl::OUString& source, const ::com::sun::star::uno::Sequence< ::rtl::OUString >& files, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs) throw( ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > SAL_CALL getContent(const ::rtl::OUString& source) throw(  ::com::sun::star::uno::RuntimeException);
	virtual ::rtl::OUString SAL_CALL getExtraData(const ::rtl::OUString& source ) throw(  ::com::sun::star::uno::RuntimeException);
};

