/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: lightfac.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: ihi $ $Date: 2006/11/14 14:57:01 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_sch.hxx"


#include "lightfac.hxx"
#include "glob.hxx"



/*************************************************************************
|*
|* Licht-Faktor ermitteln
|*
\************************************************************************/

SchLightFactor* GetLightFactor(const SdrObject& rObj)
{
	for (USHORT i = 0; i < rObj.GetUserDataCount(); i++)
	{
		SdrObjUserData *pData = rObj.GetUserData(i);
		if (pData && pData->GetId() == SCH_LIGHTFACTOR_ID)
			return (SchLightFactor*)pData;
	}

	return NULL;
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchLightFactor::SchLightFactor() :
	SdrObjUserData(SchInventor, SCH_LIGHTFACTOR_ID, 0),
	fFactor(0.0)
{
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchLightFactor::SchLightFactor(double fFac) :
	SdrObjUserData(SchInventor, SCH_LIGHTFACTOR_ID, 0),
	fFactor(fFac)
{
}

/*************************************************************************
|*
|* Kopier-Konstruktor
|*
\************************************************************************/

SchLightFactor::SchLightFactor(const SchLightFactor& rLightFactor) :
	SdrObjUserData(rLightFactor),
	fFactor(rLightFactor.fFactor)
{
}

/*************************************************************************
|*
|* Kopie erzeugen
|*
\************************************************************************/

SdrObjUserData* SchLightFactor::Clone(SdrObject *pObj) const
{
	return new SchLightFactor(*this);
}

// eof
