/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: undgrdat.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/16 20:16:57 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_sch.hxx"

//svdraw.hxx
//#define _SVDRAW_HXX ***
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV




#include "memchrt.hxx"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "undgrdat.hxx"
#include "schdll.hxx"

TYPEINIT1(SchUndoDiagramData, SchUndoAction);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchUndoDiagramData::SchUndoDiagramData(
    ChartModel & rChDoc,
    ::std::auto_ptr< SchModelData > & apOldModelData,
    ::std::auto_ptr< SchModelData > & apNewModelData ) :

        SchUndoAction( rChDoc ),

        m_apOldModelData( apOldModelData ),
        m_apNewModelData( apNewModelData )
{}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchUndoDiagramData::~SchUndoDiagramData()
{
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDiagramData::Undo()
{
    m_apOldModelData.get()->ApplyTo( rDoc );
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDiagramData::Redo()
{
    m_apNewModelData.get()->ApplyTo( rDoc );
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchUndoDiagramData::CanRepeat(SfxRepeatTarget& rView) const
{
	return FALSE;
}



