/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: unscale.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 01:03:37 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SCH_UNDOSCALE_HXX
#define _SCH_UNDOSCALE_HXX

#include "schundo.hxx"

/*************************************************************************
|*
|* Basisklasse fuer Chart-UndoActions
|*
\************************************************************************/

class SchUndoScale : public SchUndoAction
{
protected:
	BOOL   bMyNewScale;
	BOOL   bMyOldScale;

public:
	TYPEINFO();

	SchUndoScale(ChartModel& rChDoc,
				  BOOL             bOldScale,
				  BOOL             bNewScale) :
		SchUndoAction(rChDoc),
		bMyOldScale (bOldScale),
		bMyNewScale (bNewScale)
		{
		}

	virtual void Undo();
	virtual void Redo();

	virtual BOOL CanRepeat(SfxRepeatTarget& rView) const;
};

#endif	// _SCH_UNDO_HXX

