#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.22 $
#
#   last change: $Author: ihi $ $Date: 2006/11/14 15:04:39 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

EXTERNAL_WARNINGS_NOT_ERRORS := TRUE

PRJ=..

PRJNAME=sch
TARGET=schart3
LIBTARGET=NO
GEN_HID=TRUE
GEN_HID_OTHER=TRUE

# --- Settings -----------------------------------------------------------

.INCLUDE :  settings.mk

IENV!:=$(IENV);$(RES);..$/res

# --- Files --------------------------------------------------------

RESLIB1LIST=\
	$(SRS)$/app.srs	\
	$(SRS)$/dlg.srs	\
	$(SRS)$/core.srs	\
	$(SOLARCOMMONRESDIR)$/sfx.srs

.IF "$(GUI)" == "WIN"
RESLIBSPLIT1NAME=sch
RESLIB1IMAGES=$(PRJ)$/res
RESLIBSPLIT1SRSFILES=\
	$(RESLIB1LIST)
.ELSE
RESLIB1NAME=sch
RESLIB1IMAGES=$(PRJ)$/res
RESLIB1SRSFILES=\
	$(RESLIB1LIST)
.ENDIF

LIB3TARGET= $(SLB)$/sch.lib
LIB3FILES=	$(SLB)$/core.lib \
		$(SLB)$/app.lib \
		$(SLB)$/dlg.lib \
		$(SLB)$/docshell.lib \
		$(SLB)$/func.lib \
		$(SLB)$/view.lib \
		$(SLB)$/chxchart.lib \
		$(SLB)$/filter.lib	\
		$(SLB)$/xml.lib \
		$(SLB)$/a11y.lib

SHL1TARGET= sch$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= schi

SHL1VERSIONMAP= sch.map
SHL1DEF=$(MISC)$/$(SHL1TARGET).def
DEF1NAME=$(SHL1TARGET)

SHL1STDLIBS=\
	$(SVXLIB)	\
	$(SFXLIB)	\
	$(GOODIESLIB)	\
	$(BASEGFXLIB)	\
	$(SVTOOLLIB)	\
	$(VCLLIB)	\
	$(SVLLIB)	\
	$(SOTLIB)	\
	$(UNOTOOLSLIB) \
	$(TOOLSLIB)	\
	$(COMPHELPERLIB) \
	$(CPPUHELPERLIB) \
	$(CPPULIB) \
	$(SALLIB)

SHL1BASE=	0x1d100000
SHL1LIBS=   $(LIB3TARGET)
SHL1DEPN+=	makefile.mk

SHL2TARGET= schd$(UPD)$(DLLPOSTFIX)
SHL2IMPLIB= schdimp
SHL2VERSIONMAP= schd.map
SHL2DEF=$(MISC)$/$(SHL2TARGET).def
DEF2NAME=		$(SHL2TARGET)

SHL2STDLIBS= \
			$(SFX2LIB) \
			$(SVTOOLLIB) \
			$(SVLLIB) \
			$(VCLLIB) \
			$(TOOLSLIB) \
			$(UCBHELPERLIB) \
			$(CPPUHELPERLIB) \
			$(CPPULIB) \
			$(SALLIB)

SHL2OBJS=   $(SLO)$/schdet.obj \
	    $(SLO)$/detreg.obj
SHL2DEPN+=	makefile.mk

.IF "$(GUI)"!="UNX"
SHL1OBJS=   $(SLO)$/schdll.obj
.ENDIF # ! UNX

.IF "$(GUI)" == "WNT" || "$(GUI)" == "WIN"
SHL1RES=	$(RCTARGET)
.ENDIF # WNT || WIN

# --- Targets -------------------------------------------------------------

.INCLUDE :  target.mk
