/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: updatedlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2006/04/28 14:53:31 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
 
#ifndef _SFX_UPDATEDLG_HXX
#define _SFX_UPDATEDLG_HXX

// include ---------------------------------------------------------------

#include <rtl/ref.hxx>
#include <vcl/group.hxx>
#include <vcl/fixed.hxx>
#include <vcl/toolbox.hxx>
#include <vcl/field.hxx>
#include <vcl/dialog.hxx>
#include <vcl/button.hxx>
#include <vcl/status.hxx>
#include <vcl/timer.hxx>

class CheckUpdateInfo;
class SfxUpdateDialog : public ModalDialog
{
	CancelButton	                  m_aCancelPB;
    FixedText                         m_aMessageFT;

    StatusBar*                        m_pProgress;

    Timer                             m_aProgressTimer;
    USHORT                            m_nProgress;

    rtl::Reference< CheckUpdateInfo > m_aUpdateInfo;
	
    DECL_LINK( CancelHdl_Impl, PushButton * );
    DECL_LINK( ProgressHdl_Impl, Timer * );
     
public:
    SfxUpdateDialog( Window* pParent );
	virtual	~SfxUpdateDialog(); 
};

#endif // _SFX_UPDATEDLG_HXX
