/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svuidlg.hxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: hr $ $Date: 2006/10/24 14:13:05 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include <vcl/dialog.hxx>
#include <vcl/fixed.hxx>
#include <vcl/button.hxx>
#include <vcl/edit.hxx>
#include <vcl/lstbox.hxx>

#include <svtools/svmedit.hxx>	// MultiLineEdit


#ifndef INCLUDED_SO3DLLAPI_H
#include "so3/so3dllapi.h"
#endif

// class MdPasteObject ---------------------------------------------------

class SO3_DLLPUBLIC MdPasteObject : public ModalDialog
{
protected:
    FixedText aFtSource;
    FixedText aFtObjectSource;
    RadioButton aRbPaste;
    RadioButton aRbPasteLink;
    ListBox aLbInsertList;
    CheckBox aCbDisplayAsIcon;
    PushButton aPbChangeIcon;
    FixedLine aFlChoice;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    String aSObject;
public:
    MdPasteObject( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdUpdateBaselinks -----------------------------------------------

class SO3_DLLPUBLIC MdUpdateBaselinks : public ModalDialog
{
protected:
    FixedText aFtFiles;
    FixedText aFtLinks;
    FixedText aFtType;
    FixedText aFtStatus;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    PushButton aPbUpdateNow;
    PushButton aPbOpenSource;
    PushButton aPbChangeSource;
    PushButton aPbBreakLink;
    FixedText aFtFiles2;
    FixedText aFtSource2;
    FixedText aFtType2;
    FixedText aFtUpdate;
    RadioButton aRbAutomatic;
    RadioButton aRbManual;
    FixedText aFtFullFileName;
    FixedText aFtFullSourceName;
    FixedText aFtFullTypeName;
    String aStrAutolink;
    String aStrManuallink;
    String aStrBrokenlink;
    String aStrGraphiclink;
    String aStrButtonclose;
    String aStrCloselinkmsg;
    String aStrCloselinkmsgMulti;
    String aStrWaitinglink;
public:
    MdUpdateBaselinks( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdDdeLinkedit ---------------------------------------------------

class SO3_DLLPUBLIC MdDdeLinkedit : public ModalDialog
{
protected:
    FixedText aFtDdeApp;
    Edit aEdDdeApp;
    FixedText aFtDdeTopic;
    Edit aEdDdeTopic;
    FixedText aFtDdeItem;
    Edit aEdDdeItem;
    FixedLine aGroupDdeChg;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
public:
    MdDdeLinkedit( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertObjectPlugin --------------------------------------------

class SO3_DLLPUBLIC MdInsertObjectPlugin : public ModalDialog
{
protected:
    Edit aEdFileurl;
    PushButton aBtnFileurl;
    FixedLine aGbFileurl;
    MultiLineEdit aEdPluginsOptions;
    FixedLine aGbPluginsOptions;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
public:
    MdInsertObjectPlugin( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertObjectApplet --------------------------------------------

class SO3_DLLPUBLIC MdInsertObjectApplet : public ModalDialog
{
protected:
    FixedText aFtClassfile;
    Edit aEdClassfile;
    FixedText aFtClasslocation;
    Edit aEdClasslocation;
    PushButton aBtnClass;
    FixedLine aGbClass;
    MultiLineEdit aEdAppletOptions;
    FixedLine aGbAppletOptions;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
public:
    MdInsertObjectApplet( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertOleobject -----------------------------------------------

class SO3_DLLPUBLIC MdInsertOleobject : public ModalDialog
{
protected:
    RadioButton aRbNewObject;
    RadioButton aRbObjectFromfile;
    ListBox aLbObjecttype;
    Edit aEdFilepath;
    PushButton aBtnFilepath;
    CheckBox aCbFilelink;
    FixedLine aGbObject;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    String aStrFile;
public:
    MdInsertOleobject( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};


