#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: sv.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: rt $ $Date: 2005/09/08 09:41:11 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

# ------------------------------------------------------------------
#	deps auf solver 
# ------------------------------------------------------------------
.IF "$(depsolver)"!=""
MKDEPFLAGS +=$(MKDEPSOLVER)
.ENDIF
# ------------------------------------------------------------------
# DLL-Prefix
# ------------------------------------------------------------------

.IF "$(COM)" == "BLC"

TOOLSDLLPREFIX=tl
SVDLLPREFIX=sv
BROWSERDLLPREFIX=br
MAILDLLPREFIX=ma
SBASICRUNDLLPREFIX=sbr
SBASICDIALOGDLLPREFIX=sbd
SBASICCOMPILERDLLPREFIX=sbc

.ELSE

TOOLSDLLPREFIX=TL
SVDLLPREFIX=SV
BROWSERDLLPREFIX=BR
MAILDLLPREFIX=MA
SBASICRUNDLLPREFIX=SBR
SBASICDIALOGDLLPREFIX=SBD
SBASICCOMPILERDLLPREFIX=SBC

.ENDIF

# ------------------------------------------------------------------
# Ausnahmen MSC
# ------------------------------------------------------------------

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WIN"
.IF "$(PRODUCT)"=="FULL" || "$(PRODUCT)"=="full"
.IF "$(PRJNAME)"=="MAIL"
LINKFLAGS=$(LINKFLAGS)
.ELSE
LINKFLAGS=$(LINKFLAGS) /PACKC:16384 /PACKDATA
.ENDIF
.ENDIF
.IF "$(PRJNAME)" == "TOOLS" || "$(PRJNAME)" == "SV" || "$(PRJNAME)" == "SVTOOLS" || "$(PRJNAME)" == "HM2" || "$(PRJNAME)" == "SFX2" || "$(PRJNAME)" == "SVX"
.IF "$(TARGET)" != "svdem"
.IF "$(TARGET)" != "sfd"

# !!! -GEfs bei MSC nicht in TOOLS, nicht in SV und nicht in den SVTOOLS !!!
CFLAGSOBJGUIST=-Alfd -GA

# !!! Mit /PACKCODE linken
LINKFLAGS=$(LINKFLAGS) /PACKC:8192 /PACKDATA

.ENDIF
.ENDIF
.ENDIF

.IF "$(PRJNAME)"=="SVTOOLS"
LINKFLAGS=$(LINKFLAGS) /PACKC:32768 /PACKDATA
.ENDIF
.ENDIF
.ENDIF

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WNT"
.IF "$(CPU)" == "A" || "$(CPU)"=="P" || "$(CPU)" == "M"
.IF "$(PRJNAME)" == "SV"
.IF "$(TARGET)" == "sv"
LINKFLAGSSHL+= /ENTRY:DLLEntryPoint
.ENDIF
.ENDIF
.ENDIF
.ENDIF
.ENDIF

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WNT"
.IF "$(CPU)" == "I"
.IF "$(PRJNAME)" == "SV"
.IF "$(TARGET)" == "sv"
LINKFLAGSSHL+= /ENTRY:DLLEntryPoint@12
.ENDIF
#CFLAGS=$(CFLAGS) -Od
.ENDIF
.IF "$(PRJNAME)"=="TOOLS"
#CFLAGS=$(CFLAGS) -Od
.ENDIF
.ENDIF
.ENDIF
.ENDIF

# ------------------------------------------------------------------
# Ausnahmen STC
# ------------------------------------------------------------------

.IF "$(COM)" == "STC"

# keine Optimierung bei STC (\sv\win\window muss dagegen immer mit Optimierung
# uebersetzt werden)
.IF "$(TARGET)" == "window"
CFLAGSNOOPT=-o+all
.ELSE
CFLAGSOPT=
.ENDIF

# anderen Linker unter Windows (mit unserem Optlink koennen wir linken)
.IF "$(GUI)" == "WIN"
LINK=n:\bin\optlinks\optlinks
.ENDIF

.ENDIF

# ------------------------------------------------------------------
# Ausnahmen Borland
# ------------------------------------------------------------------

# ------------------------------------------------------------------
# Fuer alte Sourcen !!!
# ------------------------------------------------------------------

.IF "$(GUI)" == "WIN"
CDEFS+=-DW30
.ENDIF

.IF "$(GUI)" == "OS2"
CDEFS+=-DPM2 -DPM20
RSCFLAGS+=-DPM2 -DPM20
.ENDIF

.IF "$(COM)" == "BLC"
CDEFS+=-DTCPP
.ENDIF

.IF "$(COM)" == "STC"
CDEFS+=-DZTC
.ENDIF

.IF "$(COM)" == "ICC"
CDEFS+=-DCSET
.ENDIF
