/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: atrtox.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: obo $ $Date: 2006/09/16 21:44:47 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_sw.hxx"



#ifndef _DOC_HXX
#include <doc.hxx>
#endif
#ifndef _TXTTXMRK_HXX //autogen
#include <txttxmrk.hxx>
#endif
#ifndef _SWFONT_HXX
#include <swfont.hxx>
#endif
#ifndef _TOX_HXX
#include <tox.hxx>
#endif
#ifndef _NDTXT_HXX
#include <ndtxt.hxx>
#endif

SwTxtTOXMark::SwTxtTOXMark( const SwTOXMark& rAttr,
					xub_StrLen nStart, xub_StrLen* pEnde )
	: SwTxtAttrEnd( rAttr, nStart, nStart ),
	pEnd( 0 ),
	pMyTxtNd( 0 )
{
	((SwTOXMark&)rAttr).pTxtAttr = this;
	if( !rAttr.GetAlternativeText().Len() )
	{
		nEnd = *pEnde;
		pEnd = &nEnd;
	}
	SetDontMergeAttr( TRUE );
	SetDontMoveAttr( TRUE );
	SetOverlapAllowedAttr( TRUE );
}

SwTxtTOXMark::~SwTxtTOXMark()
{
}

xub_StrLen* SwTxtTOXMark::GetEnd()
{
	return pEnd;
}

void SwTxtTOXMark::CopyTOXMark( SwDoc* pDoc )
{
	SwTOXMark& rTOX = (SwTOXMark&)GetTOXMark();
	TOXTypes    eType   = rTOX.GetTOXType()->GetType();
	USHORT      nCount  = pDoc->GetTOXTypeCount( eType );
	const SwTOXType* pType = 0;
	const XubString& rNm = rTOX.GetTOXType()->GetTypeName();

	// kein entsprechender Verzeichnistyp vorhanden -> anlegen
	// sonst verwenden
	for(USHORT i=0; i < nCount; ++i)
	{
		const SwTOXType* pSrcType = pDoc->GetTOXType(eType, i);
		if(pSrcType->GetTypeName() == rNm )
		{
			pType = pSrcType;
			break;
		}
	}
	// kein entsprechender Typ vorhanden -> neu erzeugen
	//
	if(!pType)
	{
		pDoc->InsertTOXType( SwTOXType( eType, rNm ) );
		pType = pDoc->GetTOXType(eType, 0);
	}
	// Verzeichnistyp umhaengen
	//
	((SwTOXType*)pType)->Add( &rTOX );
}
